package elm

import (
	"golang.org/x/exp/constraints"
)

type INumber interface {
    constraints.Float | constraints.Integer
}

type ElmValueType int32

const (
	NULLPTR ElmValueType = 0
	NUMBER ElmValueType = 1
)

type ElmValue struct {
	Type ElmValueType
	Number int64
	Null int64
}

func Number(val int64) ElmValue {
	return ElmValue{Type: NUMBER, Number: val }
}